| GFA Basic Tokens Execution Manager
|==============================================================================================
| Creation: Samedi 23 Octobre 2004
| Modifications: 
| 23/10/04, 24/10/04, 25/10/04, 27/10/04, 29/10/04, 30/10/04, 31/10/04, 01/11/04, 01/11/04
| 03/11/04, 05/11/04, 06/11/04, 07/11/04, 08/11/04, 12/11/04, 13/10/04, 14/10/04, 15/11/04
| 16/11/04, 17/11/04, 20/11/04, 21/11/04, 22/11/04, 23/11/04, 24/11/04, 25/11/04, 26/11/04
| 01/12/04, 02/12/04, 03/12/04, 04/12/04, 05/12/04, 06/12/04, 11/12/04, 12/12/04, 18/01/05
| 20/01/05, 05/02/05, 06/02/05, 07/02/05, 09/02/05, 10/02/05, 11/02/05, 14/02/05, 15/02/05
| 16/02/05, 17/02/05, 18/02/05, 19/02/05, 20/02/05, 21/02/05
|==============================================================================================
|----------------------------------------------------------------------------------------------
| Ce programme permet d'excuter un programme crit en GFA Basic contenant des tokens
| d'excution.
| Ligne de commande ;
| Ex: GFATEM ("file")
|
| Auteur: Geoffrey ANNEHEIM
| Dernire modification: Mardi 15 Fvrier 2005
|----------------------------------------------------------------------------------------------
	
		.include  "os.h"
		
		.include  "Defines.h"
		.include  "Tbl_Errors.h"
		.include  "GFATEM.h"
		
		.xdef     _v200
		.xdef 	  _ti92plus
		.xdef	  _ti89
		.xdef 	  _tigcc_native
		.xdef     __ref_all___startup_code
		.xdef     __ref_all___nostub
		.xdef     __main;_main:
		.xdef     _illegal
		
|Dboguage
_illegal:	illegal
		
|*************************************************************************
|Gestion des erreurs
|*************************************************************************
_ERROR_noargument:
		move.b    #ERROR_NOARGUMENT,error_number
		jbra	  exit_program
		
_ERROR_incorrect_file:
		move.b    #ERROR_INCORRECT_FILE,error_number
		jbra	  exit_program
				
_ERROR_file_no_found:
		move.b    #ERROR_FILE_NO_FOUND,error_number
		jbra	  exit_program
		
_ERROR_incorrect_file_version:
		move.b    #ERROR_INCORRECT_FILE_VERSION,error_number
		jbra	  exit_program
		
_ERROR_tokens_section_no_found:
		move.b    #ERROR_TOKENS_SECTION_NO_FOUND,error_number
		jbra      exit_program
		
_ERROR_no_enough_memory:
		move.b    #ERROR_NO_ENOUGH_MEMORY,error_number
		jbra	  exit_program
		
		
|=========================================================================
|TEM_SaveScreen
|-------------------------------------------------------------------------
|Sauvegarde cran
|-------------------------------------------------------------------------
|input:
|
|output:
|
|destroy: a0
|=========================================================================
TEM_SaveScreen:
		|Allocation mmoire
		move.l    #LCD_SIZE,-(%SP)
		ROM_CALL  malloc
		addq.l    #4,%SP
		move.l    %a0,%d0
		|tst.l     %d0
		jbeq      _ERROR_no_enough_memory
		move.l    %d0,SaveScreen
		
		|Copie cran
		move.l	  #LCD_SIZE,-(%SP)
		move.l    #LCD_MEM,-(%SP)
		move.l    %d0,-(%SP)
		ROM_CALL  memcpy
		lea.l     12(%SP),%SP
		rts

|=========================================================================
|TEM_RestoreScreen
|-------------------------------------------------------------------------
|Restore cran
|-------------------------------------------------------------------------
|input:
|
|output:
|
|destroy: d0, a0
|=========================================================================
TEM_RestoreScreen:
		move.l    SaveScreen(%PC),%d3
		|tst.l     %d0
		jbeq      _RestoreScreen_exit
		move.l    #LCD_SIZE,-(%SP)
		move.l    %d3,-(%SP)
		move.l    #LCD_MEM,-(%SP)
		ROM_CALL  memcpy
		move.l    %d3,-(%SP)
		ROM_CALL  free
		lea.l     16(%SP),%SP
_RestoreScreen_exit:
		rts


|=========================================================================
|TEM_Initialize_Variables
|-------------------------------------------------------------------------
|Met  zro toutes les variables
|-------------------------------------------------------------------------
|input:
|
|output:
|
|destroy: d0, a0
|=========================================================================
TEM_Initialize_Variables:
		move.l	  #(End_Variables-Start_Variables),%d0
		lsr.l     #1,%d0
		subq.l    #1,%d0
	        lea.l	  Start_Variables(%PC),%a0
_Initialize_Variables_loop_erase:
		clr.w	  (%a0)+
		dbf	  %d0,_Initialize_Variables_loop_erase
		rts
	

|=========================================================================
|TEM_GetArg_ReadNameFile
|-------------------------------------------------------------------------
|Lecture du nom du fichier  partir de estack
|-------------------------------------------------------------------------
|input:
|
|output:
|  dc.b   TokensFile_NameSize = Taille du nom du fichier.
|  dc.l   TokensFile_Name     = Nom du fichier.
|
|destroy: d0, a2
|=========================================================================				
TEM_GetArg_ReadNameFile:
		|Rcupre le nom du fichier  partir de la pile estack
 		ROM_CALL2 top_estack
 		
 		|Pas d'argument
 		movea.l   %a4,%a2
 		cmpi.b    #0x2D,(%a2)				|Recherche une chaine de caractres STR_TAG
 		jbne      _ERROR_noargument			|Aucun argument spcifi
 		subq.l	  #2,%a2				|Saute caractre NULL on se retrouve  la fin de la chane
 		
 		|Remonte au dbut de la chane 
_GetArg_ReadNameFile_string_loop: 		
 		move.b    (%a2),%d0
 		subq.l    #1,%a2
 		jbne      _GetArg_ReadNameFile_string_loop
 		
 		|Vrification de la taille de la chane entre
 		pea.l     2(%a2)
 		ROM_CALL  strlen
 		addq.l    #4,%SP
 		cmpi.b    #17,%d0				|folder+'\'+file = 17 octets max
 		jbhi      _ERROR_incorrect_file
 		
 		|Copie la chane de caractres
 		lea.l     TokensFile_NameSize(%PC),%a0
 		move.b    %d0,(%a0)
 		|subq.l    #4,%SP
 		pea.l     2(%a2)
 		pea.l     TokensFile_Name(%PC)
 		ROM_CALL  strcpy
 		addq.l    #8,%SP
 		rts 						|Return	
		
		
|=========================================================================
|TEM_GetArg_OpenFile
|-------------------------------------------------------------------------
|Ouvre le fichier et vrifie son header
|-------------------------------------------------------------------------
|input:
|  dc.l   TokensFile_Name
|output:
|
|destroy: d0, d1, a0
|=========================================================================
TEM_GetArg_OpenFile:
		|Pointeur SymEntry
		lea.l     TokensFile_Name(%PC),%a0
		jbsr      FILE_GetSymByName
		lea.l     TokensFile_SymEntry(%PC),%a1
		move.l    %a0,(%a1)
		|tst.l     TokensFile_SymEntry
		jbeq      _ERROR_file_no_found

		|Lock handle
		move.w    12(%a0),-(%SP)
		ROM_CALL  HeapLock
		lea.l     TokensFile_Handle(%PC),%a0
		move.w    %d0,(%a0)
		
		|Rcupre pointeur et taille du fichier
		move.w    %d0,-(%SP)
		ROM_CALL  HeapDeref
		movea.l   %a0,%a2					|%a2 = Pointeur fichier
		move.w    (%a2)+,%d7					|%d7 = Taille du fichier
		
		|--------------------------------|		
		|Lecture Header                  |
		|--------------------------------|
		|xxxx  Signature (GFA_GTK)       |     
		|dc.b  Version (1.00)            |
		|				 |
		|dc.w  Tokens_size		 |
		|dc.w  data_number		 |
		|dc.w  data_offset		 |
		                                 |
		|dc.b  nVar_Float                |
		|dc.b  nVar_Int                  |
		|dc.b  nVar_Bool                 |
		|dc.b  nVar_String               |
		|                                |
		|dc.b  nVar_TFloat               |
		|dc.b  nVar_TInt                 |
		|dc.b  nVar_TBool                |
		|dc.b  nVar_TString              |
		|                                |
		|dc.w  TK 'Start Execution Tokens|
		|---------------------------------
		
		|Vrification fichier GTK signature
		move.l    #GTK_Signature_Size,-(%SP)
		pea.l     GTK_Signature(%PC)
		pea.l     (%a2)
		ROM_CALL  memcmp
		lea.l     16(%SP),%SP
		tst.w     %d0
		jbne      _ERROR_incorrect_file
		
		|Vrification numro de version
		addq.l    #GTK_Signature_Size,%a2		|Prpare test numro de version
		move.b    (%a2)+,%d0
		cmp.b     GTK_Version(%PC),%d0
		jbne      _ERROR_incorrect_file_version
		
		|Taille des tokens
		move.w    (%a2)+,%d5				|%d5 = Taille des tokens
		lea.l     TokensFile_Size(%PC),%a0
		move.w    %d5,(%a0)
		
		|Informations structure DATA
		clr.w     sDATA_number
		lea.l     sDATA_total_number(%PC),%a0		|Nombre de donnes
		move.w    (%a2)+,(%a0)
		move.w    (%a2)+,%d6				|%d6 = DATA_offset
		
		|Section nombre de variables
		lea.l     nVar_Float(%PC),%a0
		move.l    (%a2)+,(%a0)				|Variables simples
		lea.l     nVar_TFloat(%PC),%a0
		move.l    (%a2)+,(%a0)				|Tableaux
		
		|Vrification section TK
		move.l   #GTK_Tokens_Section_Size,-(%SP)
		pea.l     GTK_Tokens_Section(%PC)
		pea.l     (%a2)
		ROM_CALL  memcmp
		lea.l     12(%SP),%SP
		tst.w     %d0					|Vrification memcmp section TK 
		jbne      _ERROR_tokens_section_no_found
		
		|Gestion adresses tokens
		addq.l    #GTK_Tokens_Section_Size,%a2		|Saute tmoin dbut section
		lea.l     TokensFile_Data(%PC),%a0
		move.l    %a2,(%a0)
		lea.l     TokensFile_DataPtr(%PC),%a0
		move.l    %a2,(%a0)				|Adresse avancement de lecture des donnes
		lea.l     (%d5.w,%a2),%a1			|Adresse fin tokens
		lea.l     TokensFile_DataMaxAdr,%a0
		move.l    %a1,(%a0)
		
		|Gestion adresses structure DATA
		lea.l     sDATA_type_ptr(%PC),%a0		|Adresse typage donnes
		move.l    %a1,(%a0)
		lea.l     (%a2,%d6.w),%a1			|Adresse dbut donnes DATA
		lea.l     sDATA_start_ptr(%PC),%a0
		move.l    %a1,(%a0)
		lea.l     sDATA_ptr(%PC),%a0
		move.l    %a1,(%a0)
		rts
		
		
|=========================================================================
|TEM_GetArg_CloseFile
|-------------------------------------------------------------------------
|Unlock handle
|-------------------------------------------------------------------------
|input:
|  dc.w   TokensFile_Handle
|output:
|
|destroy: d0
|=========================================================================
TEM_GetArg_CloseFile:
		move.w    TokensFile_Handle,%d0    
		|tst.w     %d0
		jbeq      _GetArg_CloseFile_no_unlock_handle
		move.w    %d0,-(%SP)
                ROM_CALL  HeapUnlock
                addq.l    #2,%SP
_GetArg_CloseFile_no_unlock_handle:                      
		rts		
		

|=========================================================================
|TEM_Allocate_VarMemory
|-------------------------------------------------------------------------
|Allocation mmoire pour les variables et les tableaux
|-------------------------------------------------------------------------
|input:
|
|output:
|
|destroy: d0, d1, a0
|=========================================================================	
TEM_Allocate_VarMemory:
		moveq.l   #0,%d1					|Compte l'espace mmoire  allouer
		
		|---------|
		|VARIABLES|
		|---------|
		|VARS Flottants
		move.b    nVar_Float(%PC),%d1
		mulu.w    #SIZE_FLOAT,%d1
		
		|VARS Integer
		move.w    %d1,-(%SP)
		clr.w     %d0
		move.b    nVar_Int(%PC),%d0
		mulu.w    #SIZE_INTEGER,%d0
		add.w     %d0,%d1
		
		|VARS Bool
		move.w    %d1,-(%SP)
		clr.w     %d0
		move.b    nVar_Bool(%PC),%d0
		
		|Octet d'alignement si ncessaire
		move.b    %d0,%d2
		andi.b    #1,%d2
		|tst.b     %d0
		jbeq      _Allocate_VarMemory_nVarBool_is_pair
		addq.l    #1,%d0
_Allocate_VarMemory_nVarBool_is_pair:
		add.w     %d0,%d1
		
		|VARS String
		move.w    %d1,-(%SP) 
		clr.w     %d0
		move.b    nVar_String(%PC),%d0
		mulu.w    #SIZE_DESCRIPTOR,%d0
		add.w     %d0,%d1
		 
		 
		|--------|
		|TABLEAUX|
		|--------|
		|TABS Flottants
		move.w    %d1,-(%SP)
		clr.w	  %d0
		move.b    nVar_TFloat(%PC),%d0
		mulu.w    #SIZE_DESCRIPTOR,%d0
		add.w     %d0,%d1
		
		|TABS Integer
		move.w    %d1,-(%SP)
		clr.w     %d0
		move.b    nVar_TInt(%PC),%d0
		mulu.w    #SIZE_DESCRIPTOR,%d0
		add.w     %d0,%d1
		
		|TABS Bool
		move.w    %d1,-(%SP)
		clr.w     %d0
		move.b    nVar_TBool(%PC),%d0
		mulu.w    #SIZE_DESCRIPTOR,%d0
		add.w     %d0,%d1
		
		|TABS String
		move.w    %d1,-(%SP)
		clr.w     %d0
		move.b    nVar_TString(%PC),%d0
		mulu.w    #SIZE_DESCRIPTOR,%d0
		add.w     %d0,%d1
		
		|Allocation de l'espace mmoire
		move.l    %d1,%d3					|Sauvegarde d1
		move.l    %d1,-(%SP)
		ROM_CALL  malloc
		
		|Attribution des espaces
		lea.l     MEM_VARS(%PC),%a1
		move.l    %a0,(%a1)
		lea.l     VAR_FLOAT(%PC),%a1
		move.l    %a0,(%a1)
		move.l    %a0,%d0
		add.w     16(%SP),%d0
		lea.l     VAR_INTEGER(%PC),%a1
		move.l    %d0,(%a1)
		move.l    %a0,%d0
		add.w     14(%SP),%d0
		lea.l     VAR_BOOL(%PC),%a1
		move.l    %d0,(%a1)
		move.l    %a0,%d0
		add.w     12(%SP),%d0
		lea.l     VAR_STRING(%PC),%a1
		move.l    %d0,(%a1)
		
		move.l    %a0,%d0
		add.w     10(%SP),%d0
		lea.l     MEM_TABS(%PC),%a1
		move.l    %d0,(%a1)
		lea.l     TAB_FLOAT(%PC),%a1
		move.l    %d0,(%a1)
		move.l    %a0,%d0
		add.w     8(%SP),%d0
		lea.l     TAB_INTEGER(%PC),%a1
		move.l    %d0,(%a1)
		move.l    %a0,%d0
		add.w     6(%SP),%d0
		lea.l     TAB_BOOL(%PC),%a1
		move.l    %d0,(%a1)
		move.l    %a0,%d0
		add.w     4(%SP),%d0
		lea.l     TAB_STRING(%PC),%a1
		move.l    %d0,(%a1)
		
		|Vide pile SP
		lea.l     7*2+4(%SP),%SP
		
		|Vrification allocation
		move.l    %a0,%d0
		|tst.l     %d0
		jbeq	  _ERROR_no_enough_memory
		
		|Initialise zone avec des octets NULL
		move.l    %d3,-(%SP)					|Nombres d'octets
		clr.w     -(%SP)					|Caractre NULL
		move.l    %d0,-(%SP)					|Adresse
		ROM_CALL  memset
		lea.l     10(%SP),%SP
		
		|Initialise les chanes de caractres
		moveq.l   #0,%d0
		move.b    nVar_String(%PC),%d0
		move.l    VAR_STRING(%PC),%a0
		jbra      TokensExec_InitEmptyString


|=========================================================================
|TEM_Unallocate_VarMemory
|-------------------------------------------------------------------------
|Efface allocation mmoire pour les variables et les tableaux
|-------------------------------------------------------------------------
|input:
|
|output:
|
|destroy:
|=========================================================================
_Unallocate_VarMemory_table:
		move.l    (%a2),-(%SP)
		ROM_CALL  free
		addq.l    #4,%SP
		rts

_Unallocate_VarMemory_TFloat_free:
		jbsr      _Unallocate_VarMemory_table
		jbra      _Unallocate_VarMemory_TFloat_continue
		
_Unallocate_VarMemory_TInt_free:
		jbsr      _Unallocate_VarMemory_table
		jbra      _Unallocate_VarMemory_TInt_continue
		
_Unallocate_VarMemory_TBool_free:
		jbsr      _Unallocate_VarMemory_table
		jbra      _Unallocate_VarMemory_TBool_continue
		
_Unallocate_VarMemory_TString_free:
		move.l    %d3,-(%SP)					|Sauvegarde %d3 					
		move.w    4(%a2),%d0					|Nombre de dimensions
		move.l    (%a2),%a3					|Zone descripteurs
		jbsr      TokensExec_DeleteTabString
		move.l    (%SP)+,%d3					|Restaure %d3	
		jbsr      _Unallocate_VarMemory_table
		jbra      _Unallocate_VarMemory_TString_continue
		
TEM_Unallocate_VarMemory:
		tst.l	  MEM_VARS
		jbeq      _Unallocate_VarMemory_noblock
		
		|Efface les chanes de caractres
		moveq.l   #0,%d3
		move.b    nVar_String(%PC),%d3
		move.l    VAR_STRING(%PC),%a3
		jbsr      TokensExec_DeleteString
		
		|Efface les tableaux
		|T_FLOAT
		moveq.l   #0,%d3
		move.b    nVar_TFloat(%PC),%d3
		movea.l   TAB_FLOAT(%PC),%a2
		dbf       %d3,_Unallocate_VarMemory_TFloat_loop
		jbra      _Unallocate_VarMemory_TFloat_end
_Unallocate_VarMemory_TFloat_loop:
		tst.l     (%a2)
		jbne      _Unallocate_VarMemory_TFloat_free
_Unallocate_VarMemory_TFloat_continue:
		addq.l    #SIZE_DESCRIPTOR,%a2
		dbf       %d3,_Unallocate_VarMemory_TFloat_loop
		
		|T_INTEGER
_Unallocate_VarMemory_TFloat_end:
		moveq.l   #0,%d3
		move.b    nVar_TInt(%PC),%d3
		movea.l   TAB_INTEGER(%PC),%a2
		dbf       %d3,_Unallocate_VarMemory_TInt_loop
		jbra      _Unallocate_VarMemory_TInt_end
_Unallocate_VarMemory_TInt_loop:
		tst.l     (%a2)
		jbne      _Unallocate_VarMemory_TInt_free
_Unallocate_VarMemory_TInt_continue:
		addq.l    #SIZE_DESCRIPTOR,%a2
		dbf       %d3,_Unallocate_VarMemory_TInt_loop
		
		|T_BOOL
_Unallocate_VarMemory_TInt_end:
		moveq.l   #0,%d3
		move.b    nVar_TBool(%PC),%d3
		movea.l   TAB_BOOL(%PC),%a2
		dbf       %d3,_Unallocate_VarMemory_TBool_loop
		jbra      _Unallocate_VarMemory_TBool_end
_Unallocate_VarMemory_TBool_loop:
		tst.l     (%a2)
		jbne      _Unallocate_VarMemory_TBool_free
_Unallocate_VarMemory_TBool_continue:
		addq.l    #SIZE_DESCRIPTOR,%a2
		dbf       %d3,_Unallocate_VarMemory_TBool_loop
		
		|T_STRING
_Unallocate_VarMemory_TBool_end:
		moveq.l   #0,%d3
		move.b    nVar_TString(%PC),%d3
		movea.l   TAB_STRING(%PC),%a2
		dbf       %d3,_Unallocate_VarMemory_TString_loop
		jbra      _Unallocate_VarMemory_TString_end
_Unallocate_VarMemory_TString_loop:
		tst.l     (%a2)
		jbne      _Unallocate_VarMemory_TString_free
_Unallocate_VarMemory_TString_continue:
		addq.l    #SIZE_DESCRIPTOR,%a2
		dbf       %d3,_Unallocate_VarMemory_TString_loop
_Unallocate_VarMemory_TString_end:
		
		|Efface buffer des variables
		move.l	  MEM_VARS(%PC),-(%SP)
		ROM_CALL  free
		addq.l    #4,%SP
_Unallocate_VarMemory_noblock:
		rts		


|==========================================================================
|TEM_Allocate_ES_DT_and_FOR
|--------------------------------------------------------------------------
|Allocation mmoire pour la pile ES, le tampon de donnes DT et la pile FOR
|--------------------------------------------------------------------------
|input:
|
|output:
|
|destroy: a0
|==========================================================================
TEM_Allocate_ES_DT_and_FOR:
		|Allocation pile ES  
		move.l    #ES_SIZE,-(%SP)
		ROM_CALL  malloc
		addq.l    #4,%SP
		move.l    %a0,%d0
		|tst.l     %d0
		jbeq      _ERROR_no_enough_memory
		lea.l     ptrStart_ES(%PC),%a0
		move.l    %d0,(%a0)
		addi.l    #ES_SIZE,%d0
		lea.l     ptrEnd_ES(%PC),%a0
		move.l    %d0,(%a0)
		
		|Allocation tampon DT
		move.l    #DT_SIZE,-(%SP)
		ROM_CALL  malloc
		addq.l    #4,%SP
		move.l    %a0,%d0
		|tst.l     %d0
		jbeq      _ERROR_no_enough_memory
		lea.l     ptrData_DT(%PC),%a0
		move.l    %d0,(%a0)
		lea.l     DTO(%PC),%a0
		move.l    %d0,(%a0)
		
		|Allocation pile FOR
		move.l    #FOR_SIZE,-(%SP)
		ROM_CALL  malloc
		addq.l    #4,%SP
		move.l    %a0,%d0
		|tst.l     %d0
		jbeq      _ERROR_no_enough_memory
		lea.l     ptrData_FOR(%PC),%a0
		move.l    %d0,(%a0)
		lea.l     ptrFOR(%PC),%a0
		move.l    %d0,(%a0)
		rts
		
		
|=================================================================================
|TEM_Unallocate_ES_DT_and_FOR
|---------------------------------------------------------------------------------
|Efface allocation mmoire pour la pile ES, le tampon de donnes DT et la pile FOR
|---------------------------------------------------------------------------------
|input:
|
|output:
|
|destroy:
|=================================================================================
TEM_Unallocate_ES_DT_and_FOR:
		move.l    ptrStart_ES(%PC),%d0
		|tst.l     %d0
		jbeq      _Unallocate_ES_DT_and_FOR_no_delete_ES
		move.l    %d0,-(%SP)
		ROM_CALL  free
		addq.l    #4,%SP
_Unallocate_ES_DT_and_FOR_no_delete_ES:
		move.l    ptrData_DT(%PC),%d0
		|tst.l     %d0
		jbeq      _Unallocate_ES_DT_and_FOR_no_delete_DT
		move.l    %d0,-(%SP)
		ROM_CALL  free
		addq.l    #4,%SP
_Unallocate_ES_DT_and_FOR_no_delete_DT:
		move.l    ptrData_FOR(%PC),%d0
		|tst.l     %d0
		jbeq      _Unallocate_ES_DT_and_FOR_no_delete_FOR
		move.l    %d0,-(%SP)
		ROM_CALL  free
		addq.l    #4,%SP
_Unallocate_ES_DT_and_FOR_no_delete_FOR:
		rts


|==========================================================================
|TEM_Allocate_Others
|--------------------------------------------------------------------------
|Autres allocations mmoire
|--------------------------------------------------------------------------
|input:
|
|output:
|
|destroy: %a0
|==========================================================================
TEM_Allocate_Others:
		move.l    #STRING_BUFFER_SIZE,-(%SP)
		ROM_CALL  malloc
		addq.l    #4,%SP
		move.l    %a0,%d0
		|tst.l     %d0
		jbeq      _ERROR_no_enough_memory  
		lea.l     string_buffer(%PC),%a0
		move.l    %d0,(%a0) 
		rts

|==========================================================================
|TEM_Unallocate_Others
|--------------------------------------------------------------------------
|Efface les autres allocations mmoire
|--------------------------------------------------------------------------
|input:
|
|output:
|
|destroy: %a0
|==========================================================================
TEM_Unallocate_Others:
		move.l    string_buffer(%PC),%d0
		jbeq      _TEM_Unallocate_Others_exit
		move.l    %d0,-(%SP)
		ROM_CALL  free
		addq.l    #4,%SP
_TEM_Unallocate_Others_exit:
		rts


|=========================================================================
|TEM_Init_Interrupts
|-------------------------------------------------------------------------
|Rglages des interruptions
|-------------------------------------------------------------------------
|input:
|
|output:
|
|destroy:
|=========================================================================
TEM_Init_Interrupts:
		|Sauvegardes les interruptions
		lea.l     OldInt1(%PC),%a0
		move.l    0x64,(%a0)
		lea.l     OldInt2(%PC),%a0
		move.l    0x68,(%a0)
		lea.l     OldInt5(%PC),%a0
		move.l    0x74,(%a0)
				
		|Modification de la table des interruption Auto-Ints (1, 2, 5)
		bclr.b    #2,0x600001				|Dsactive protection en criture
		move.l    #Interrupt1,0x64
		move.l    #Interrupt2,0x68
		move.l    #__dummy_handler__,0x74
		bset.b    #2,0x600001				|Active protection en criture
		lea.l     SetInts(%PC),%a0
		move.w    #-1,(%a0)
		rts
		
		
|=========================================================================
|TEM_Uninit_Interrupts
|-------------------------------------------------------------------------
|Restaure interruptions
|-------------------------------------------------------------------------
|input:
|
|output:
|
|destroy: %d0
|=========================================================================
TEM_Uninit_Interrupts:
		|Les interruptions ont t modifies?
		move.w    SetInts (%PC),%d0
		|tst.w     %d0
		jbeq      _Uninit_Interrupts_end
		
		bclr.b    #2,0x600001				|Dsactive protection en criture
		move.l    OldInt1(%PC),0x64
		move.l    OldInt2(%PC),0x68
		move.l    OldInt5(%PC),0x74
		bset.b    #2,0x600001				|Active protection en criture
_Uninit_Interrupts_end:
		rts


|=========================================================================
|TEM_Calculator_Init
|-------------------------------------------------------------------------
|Variables spcifiques  la calculatrice
|-------------------------------------------------------------------------
|input:
|
|output:
|
|destroy:
|=========================================================================
_Calculator_Init_TI89:
		lea.l     LCD_WIDTH(%PC),%a0
		move.w    #159,(%a0)
		lea.l     LCD_HEIGHT(%PC),%a0
		move.w    #99,(%a0)
		lea.l     LCD_LINE_BYTES(%PC),%a0
		move.w    #20,(%a0)
		rts
		
TEM_Calculator_Init:
		|Hardware version
		jbsr      __get_hw_version
		lea.l     HARDWARE_VERSION(%PC),%a0
		move.w    %d0,(%a0)
		
		|ROM_BASE
		move.l    200.w,%d0
		and.l     #14680064,%d0
		lea.l     ROM_BASE(%PC),%a0
		move.l    %d0,(%a0)
				
		|Modle de calculatrice
		move.w    __calculator,%d0
		lea.l     CALCULATOR(%PC),%a0
		move.w    %d0,(%a0)
		|tst.w     %d0
		jbeq      _Calculator_Init_TI89
		lea.l     LCD_WIDTH(%PC),%a0
		move.w    #239,(%a0)
		lea.l     LCD_HEIGHT(%PC),%a0
		move.w    #127,(%a0)
		lea.l     LCD_LINE_BYTES(%PC),%a0
		move.w    #30,(%a0)
		rts
		
			
|=========================================================================
|TEM_Parameters_init
|-------------------------------------------------------------------------
|Initialisation de parameters
|-------------------------------------------------------------------------
|input:
|
|output:
|
|destroy: %d0, %a0
|=========================================================================
TEM_Parameters_Init:
		lea.l     PARAM_PRINT_DIGITS(%PC),%a0
		move.b    #PRINT_DIGITS,(%a0)
		lea.l     PARAM_SHOW_ENDTEXT(%PC),%a0
		move.w    #SHOW_ENDTEXT,(%a0)
		lea.l     PARAM_PRINT_AT(%PC),%a0
		move.w    #FALSE,(%a0)
		
		lea.l     PARAM_FONT(%PC),%a0
		move.b    #FONT,(%a0)
		lea.l     PARAM_FONT_DIVx(%PC),%a0
		move.b    #FONT_DIVx,(%a0)
		lea.l     PARAM_FONT_DIVy(%PC),%a0
		move.b    #FONT_DIVy,(%a0)
		move.w    #FONT,-(%SP)
		ROM_CALL  FontSetSys
		
		lea.l     PARAM_PRINT_ATx(%PC),%a0
		move.w    #PRINT_ATx,(%a0)
		lea.l     PARAM_PRINT_ATy(%PC),%a0
		move.w    #PRINT_ATy,(%a0)
		lea.l     PARAM_PRINT_REAL_ATx(%PC),%a0
		move.w    #PRINT_REAL_ATx,(%a0)
		lea.l     PARAM_PRINT_REAL_ATy(%PC),%a0
		move.w    #PRINT_REAL_ATy,(%a0)
		move.w    #PRINT_REAL_ATy,-(%SP)
		move.w    #PRINT_REAL_ATx,-(%SP)
		ROM_CALL  MoveTo

		lea.l     PARAM_REPEAT_KEYDELAY(%PC),%a0
		move.w    #DEFAULT_REPEAT_KEYDELAY,(%a0)
		lea.l     PARAM_BETWEEN_KEYDELAY(%PC),%a0
		move.w    #DEFAULT_BETWEEN_KEYDELAY,(%a0)
		
		lea.l     PARAM_SPRITE_LCD_MEM(%PC),%a0
		move.l    #DEFAULT_SPRITE_LCD_MEM,(%a0)
		
		|Randomize
		move.b    0x600017,%d0
	        clr.l     __randseed
	        move.b    %d0,__randseed+3
	        
	        |SetCurClip (&(SCR_RECT){{0, 0, LCD_WIDTH-1, LCD_HEIGHT-1}});
	        /*lea.l     SCR_RECT(%PC),%a0
	        move.l    %a0,-(%SP)
	        move.b    #0,(%a0)+
	        move.b    #0,(%a0)+
	        move.b    #50,(%a0)+
	        move.b    #50,(%a0)*/
	        lea.l     SCR_RECT(%PC),%a0
	        move.l    %a0,-(%SP)
	        clr.w     (%a0)+
	        move.b    LCD_WIDTH+1(%PC),(%a0)+
	        move.b    LCD_HEIGHT+1(%PC),(%a0)
	        ROM_CALL  SetCurClip
	        
	        |Attribut par dfaut
	        lea.l     PARAM_CURATTR(%PC),%a0
	        move.w    #DEFAULT_CURATTR,(%a0)
	        move.w    (%a0),-(%SP)
	        ROM_CALL  SetCurAttr
	        lea.l     12(%SP),%SP
	        
	        |Input Length
	        lea.l     PARAM_INPUT_LENGTH(%PC),%a0
	        move.w    #INPUT_LENGTH,(%a0)
		rts


|=========================================================================
|Programme principal
|=========================================================================		
__main:
  		movem.l   %d3-%d7/%a2-%a6,-(%SP) 		|Sauvegarde les registres
 		link.w 	  %a6,#0
 		
 		jbsr      TEM_Initialize_Variables		|Initialise variables  zro
 		jbsr      TEM_Calculator_Init			|Initialise variables dpendant de la calculatrice
 		jbsr      TEM_Parameters_Init			|Initialise parameters
 		
 		jbsr      TEM_SaveScreen			|Sauvegarde cran
 		
 		jbsr      TEM_GetArg_ReadNameFile		|Lecture de l'argument
 		jbsr	  TEM_GetArg_OpenFile			|Ouvre fichier avec vrification du format
 		
 		jbsr      TEM_Allocate_VarMemory		|Allocation mmoire pour les variables
 		jbsr      TEM_Allocate_ES_DT_and_FOR		|Allocation pile ES, tampon DT et pile FOR
 		jbsr      TEM_Allocate_Others			|Effectue les autres allocations (gestion de TEM)
 		jbsr      TEM_Init_Interrupts			|Prpare interruptions
 		
 		lea.l     counter_time(%PC),%a0			|Compteur de temps intialis
 		clr.l     (%a0)
 		jbsr      TokensExec_Run			|Boucle d'execution des tokens

exit_program:       
 		jbsr      TEM_Uninit_Interrupts			|Restaure interruptions
 		jbsr      TEM_Unallocate_Others			|Efface les autres allocations (gestion de TEM)
 		jbsr	  TEM_Unallocate_ES_DT_and_FOR		|Efface allocation pile ES, tampon DT, pile FOR	
 		jbsr      TEM_Unallocate_VarMemory		|Efface espace mmoires pour les variables
 		
 		jbsr      TEM_GetArg_CloseFile			|Ferme le fichier de tokens
 		
 		ROM_CALL  HeapCompress				|Garbage Collect de la RAM
 		
 		jbsr      TEM_RestoreScreen			|Restaure cran
 		
 		|Affichage erreur
 		moveq.l   #0,%d0
 		move.b    error_number(%PC),%d0
 		|tst.b     %d0
 		jbeq      _main_no_error
 		lea.l     Tbl_Error(%PC),%a0
   		move.l    (%a0,%d0),-(%SP)
   		ROM_CALL  ST_helpMsg
   		addq.l    #4,%SP

_main_no_error: 
		ROM_CALL  GKeyFlush				|Key Flush
		
 		unlk      %a6
 		movem.l   (%SP)+,%d3-%d7/%a2-%a6 		|Restaure les registres
  		rts
  		
|-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
|FIN DU PROGRAMME
|-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
		.end
		